<template lang="pug">
q-field.collection-menu-ange(
	:label="label"
	dense
	outlined
	hide-bottom-space
	stack-label
)
	template(#control)
		.q-gutter-md.q-py-md.collection-menu-ange__list
			.menu-day(v-for="(item, index) in model", :key="item.assigned" flat bordered)

				.flex.full-width.vertical-middle.q-mb-md
					.text-h5 Дата {{ item.assigned }}
				.menu-day__info
					.q-gutter-md
						collection-dishes(
							v-model="item.breakfast"
							label="Завтрак"
						)
						collection-dishes(
							v-model="item.lunch"
							label="Обед"
						)
						collection-dishes(
							v-model="item.dinner"
							label="Ужин"
						)

</template>

<script lang="ts">
	import { computed, defineComponent, reactive, ref, isReactive, watch } from 'vue'
	import { IDayMenu } from '@/plugins/utils/types'
	import CollectionDishes from '@/pages/kitchen/components/CollectionDishes.vue'
	import UiTooltip from '@/components/ui/UiTooltip.vue'

	export default defineComponent({
		name: 'CollectionMenuRange',

		components: {
			CollectionDishes,
			UiTooltip,
		},

		props: {
			modelValue: {
				type: Array,
				default: () => [],
			},
			dates: {
				type: Array,
				default: () => [],
			},
			label: {
				type: String,
				default: 'Меню',
			},
			required: {
				type: Boolean,
				default: false,
			},
		},

		emits: ['update:modelValue'],

		setup(props, { emit }) {
			const model = computed({
				get: () => {
					return props.modelValue as IDayMenu[]
				},
				set: (val) => {
					console.info('set', val)
					emit('update:modelValue', val)
				},
			})

			watch(
				() => props.dates,
				(date) => {
					console.info('date', date)
					const update = date.map((date, idx) => {
						const value =
							props.modelValue && props.modelValue.length
								? (props.modelValue[idx] as IDayMenu)
								: ({} as IDayMenu)
						return {
							id: value.id || undefined,
							assigned: date as string,
							breakfast: value.breakfast || [],
							lunch: value.lunch || [],
							dinner: value.dinner || [],
						}
					})

					console.info('update', update)

					model.value = [...update]
				},
			)

			const getRules = computed(() => {
				const hasValue = props.required ? [(val: IDayMenu[]) => val.length > 0 || ''] : []

				return [...hasValue]
			})

			return {
				model,
				getRules,
			}
		},
	})
</script>

<style lang="scss" scoped>
	.menu-day {
		display: flex;
		flex-wrap: wrap;

		&__info {
			flex: 1 1 0;
		}

		&__image {
			width: 100%;
			margin-top: 16px;

			@include breakPoint($breakpoint-sm) {
				width: 220px;
				margin-top: 0;
				margin-left: 16px;
			}
		}

		&__instruction {
			&:deep(.q-field__control-container) {
				min-height: 117px;
			}
		}
	}

	.collection-menu-ange {
		&__list {
			display: block;
			width: 100%;
		}

		&:deep(.q-field__control-container) {
			padding-top: 0 !important;
		}

		&:deep(.q-field__label) {
			transform: translateY(-85%) scale(0.75) !important;
			z-index: 1;
			background: $main-background;
			padding: 0 5px;
			margin-left: -5px;
			right: auto;
			max-width: calc(135% + 10px);
		}
	}
</style>
